/*******************************************************************************
 *    ___                  _   ____  ____
 *   / _ \ _   _  ___  ___| |_|  _ \| __ )
 *  | | | | | | |/ _ \/ __| __| | | |  _ \
 *  | |_| | |_| |  __/\__ \ |_| |_| | |_) |
 *   \__\_\\__,_|\___||___/\__|____/|____/
 *
 * Copyright (C) 2014-2017 Appsicle
 *
 * This program is free software: you can redistribute it and/or  modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/

package com.questdb.net.ha;

import com.questdb.net.ha.config.ServerNode;

public interface ClusterStatusListener {

    /**
     * Activates producer on current node. This can only happen once in a lifespan of cluster node.
     * Node cannot become neither passive nor active again unless it cluster controller is restarted.
     */
    void goActive();

    /**
     * Notifies producer that current node is passive. Current active node is provided as a parameter.
     * From passive state node can become either active or passive again. Implementations should check
     * if active node has changed to avoid repeating work.
     *
     * @param activeNode current active node
     */
    void goPassive(ServerNode activeNode);

    /**
     * Cluster controller shutdown callback.
     */
    void onShutdown();
}
