/*******************************************************************************
 *    ___                  _   ____  ____
 *   / _ \ _   _  ___  ___| |_|  _ \| __ )
 *  | | | | | | |/ _ \/ __| __| | | |  _ \
 *  | |_| | |_| |  __/\__ \ |_| |_| | |_) |
 *   \__\_\\__,_|\___||___/\__|____/|____/
 *
 * Copyright (C) 2014-2017 Appsicle
 *
 * This program is free software: you can redistribute it and/or  modify
 * it under the terms of the GNU Affero General Public License, version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/

package com.questdb.query;

import com.questdb.Journal;
import com.questdb.ex.JournalException;
import com.questdb.misc.Rows;
import com.questdb.std.LongList;

public class OrderedResultSet<T> extends ResultSet<T> {
    public OrderedResultSet(Journal<T> journal, LongList rowIDs) {
        super(journal, rowIDs);
    }

    public long getMaxTimestamp() throws JournalException {
        if (size() == 0) {
            return 0;
        }
        long rowID = getRowID(size() - 1);
        int timestampColumnIndex = getJournal().getMetadata().getTimestampIndex();
        return getJournal().getPartition(Rows.toPartitionIndex(rowID), true).getLong(Rows.toLocalRowID(rowID), timestampColumnIndex);
    }
}
